//+------------------------------------------------------------------+
//| RSI_Env.mq4.mq4
//| NoName (and-)
//| http://www.tradersforum.net.ru/forum/index.php?showtopic=267&st=0
//+------------------------------------------------------------------+
#property copyright "NoName (and-)"
#property link      "http://www.tradersforum.net.ru/forum/index.php?showtopic=267&st=0"

//---- input parameters---------
extern int     RSI_period=14;
extern int     Env_period=25;
extern int     Env_shift=1;
extern double  Env_deviation=20;
//------------------------------
extern int     TP=20;
extern int     SL=20;
extern double  Lot=1;
extern int     Slippage=3;
//-------------------
int   up_lim  =75;     // 
int   low_lim =25;     // 
//-------------------
int ticket;

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (Env_deviation==0) Env_deviation=0.1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//*********************************************************************

double RSI_array[49];
//------   RSI-----------------
int    i=0;
while (i<50)
 {
RSI_array[i]= iRSI(NULL, 0, RSI_period, PRICE_CLOSE, i);
i++;
 }
//------------------------------------------------------


ArraySetAsSeries(RSI_array,true);

double
En0_low=iEnvelopesOnArray(RSI_array,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,0);

double
En0_up=iEnvelopesOnArray(RSI_array,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,0);

double RSI_0=iRSI(NULL, 0, RSI_period, PRICE_CLOSE, 0);
double RSI_1=iRSI(NULL, 0, RSI_period, PRICE_CLOSE, 1);
 
//=====      =========================================================

int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  {  
//---------   ----------------------------
  if   (  /*(RSI_1<low_lim)  &&
          (RSI_0>low_lim)  &&*/
          (RSI_1<En0_low)  &&
          (RSI_0>En0_low)  )
   {
  ticket=OrderSend(Symbol(),0,Lot,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   BUY #", GetLastError()); return (0); }              
   }
//------------------------------------------------------------------

//--------   ------------------------------
  if  ( /*(RSI_1>up_lim)  &&
          (RSI_0<up_lim)  &&  */
          (RSI_1>En0_up)  &&
          (RSI_0<En0_up)) 
   {       
  ticket=OrderSend(Symbol(),1,Lot,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   SELL #", GetLastError()); return (0); }              
   }
  
//------------------------------------------------------------------
  }
//===============================================================================================


//----
   return(0);
  }
//+------------------------------------------------------------------+